<script>
    export let subplotLayout;
    export let xScale;
    export let tickPadding = 4;
    export let tickSize = 6;

    // Where to plot the axis
    $: leftMargin = xScale.range()[0];
    $: left = leftMargin;
    $: bottom = subplotLayout.y+subplotLayout.h;
    $: top = subplotLayout.y;
    $: center = 0.5 * (subplotLayout.yScale.range()[0] + subplotLayout.yScale.range()[1])

</script>

<g class="yaxis">
    <!-- Vertical axis line, spanning the full domain -->
    <line x1={left}
          x2={left}
          y1={bottom}
          y2={top}
          stroke='black'
          stroke-width='1.5px'/>

    <!-- Primary axis ticks -->
    {#if (subplotLayout.scale === "log10")}
        {#each subplotLayout.logTicks as logTick}
            {#if logTick.multiplier == 1}
                <line x1={left-tickSize}
                      x2={left}
                      y1={subplotLayout.yScale(logTick.value)}
                      y2={subplotLayout.yScale(logTick.value)}
                      stroke="black"
                      stroke-width="0.75px"/>
                {#if subplotLayout.yaxis_annotation=="visible"}
                    <text x={left-tickSize-tickPadding}
                          y={subplotLayout.yScale(logTick.value)}
                          font-size="12px"
                          alignment-baseline="middle"
                          text-anchor="end">10<tspan baseline-shift="super" font-size="9px">{logTick.exponent}</tspan>
                    </text>
                {/if}
            {:else}
                <line x1={left-3}
                      x2={left}
                      y1={subplotLayout.yScale(logTick.value)}
                      y2={subplotLayout.yScale(logTick.value)}
                      stroke="black"
                      stroke-width="0.75px"/>
            {/if}
        {/each}
    {:else}
        {#each subplotLayout.ticks as tick}
            <line x1={left-tickSize}
                  x2={left}
                  y1={subplotLayout.yScale(tick)}
                  y2={subplotLayout.yScale(tick)}
                  stroke="black"
                  stroke-width="0.75px"/>
            {#if subplotLayout.yaxis_annotation=="visible"}
                <text x={left-tickSize-tickPadding}
                      y={subplotLayout.yScale(tick)}
                      font-size="12px"
                      alignment-baseline="middle"
                      text-anchor="end">{tick}</text>
            {/if}
        {/each}
    {/if}
    {#if subplotLayout["y_label"]}
        <text transform="translate({left-50}, {center}) rotate(-90)"
              x=0
              y=0
              font-size="12px"
              font-weight="bold"
              alignment-baseline="middle"
              text-anchor="middle">{subplotLayout["y_label"]}</text>
    {/if}
</g>
